#include <string>
#include <iostream>
#include <list>

using namespace std;

class Darbas
{
   std::string name;
   std::string date;
   public:
      Darbas(std::string name, std::string date);
      std::string getName();
      std::string getDate();
};
//------------------------------------------------------------
class Shop {
   private:
      std::string grupe;
      std::list<Darbas*> darbai;
   public:
      Shop(std::string grupe);
      ~Shop();
      std::string getGrupe();
      void printGroup();
      void printGroupPagalLaika(std::string nuo, std::string iki);
      void iSarasa(std::string name, std::string date);
};
//------------------------------------------------------------
class Palyginti {
   public:
      bool operator() (Shop* a, Shop* b) {
         return (a->getGrupe() < b->getGrupe());
      }
};
//------------------------------------------------------------
class GroupList
{
   std::list<Shop*> groupList;
   public:
      ~GroupList();
      void printSarasa();
      void surinkSiuksles();
      void printLaikotarpi();
      void printVienaSarasa();
      void iSarasa(std::string grupe, std::string name, std::string date);
      void addToSarasas();
      void createNewGroup();
};
//------------------------------------------------------------
Darbas::Darbas(std::string name, std::string date)
{
  this->name=name;
  this->date=date;
}
//------------------------------------------------------------
string Darbas::getName()
{
  return(name);
}
//------------------------------------------------------------
string Darbas::getDate()
{
  return(date);
}
//------------------------------------------------------------
Shop::Shop(std::string grupe)
{
  this->grupe=grupe;
}
//------------------------------------------------------------
Shop::~Shop()
{
  list<Darbas*>::iterator i;
   for (i = darbai.begin();  i != darbai.end();  i++)
       delete (*i);
       darbai.clear();
}
//------------------------------------------------------------
string Shop::getGrupe()
{
  return(grupe);
}
//------------------------------------------------------------
void Shop::printGroup()
{
  cout<<grupe<<":"<<endl;
  list<Darbas*>::iterator i=darbai.begin();
  for(; i!=darbai.end(); i++)
     cout<<"   "<<(*i)->getName()<<", "<<(*i)->getDate()<<endl;
  cout<<endl;
}
void Shop::printGroupPagalLaika(std::string nuo, std::string iki)
{
  cout<<grupe<<":"<<endl;
  list<Darbas*>::iterator i=darbai.begin();
  for(; i!=darbai.end(); i++)
     if((nuo <= (*i)->getDate()) && ((*i)->getDate() <= iki))
        cout<<"   "<<(*i)->getDate()<<" - "<<(*i)->getName()<<endl;
  cout<<endl;
}
void Shop::iSarasa(std::string name, std::string date)
{
  darbai.push_back(new Darbas(name, date));
}
//------------------------------------------------------------
GroupList::~GroupList()
{
   list<Shop*>::iterator vi;
   for (vi = groupList.begin();  vi != groupList.end();  vi++)
       delete (*vi);           // delete Shop objektus
       groupList.clear();      // delete Shop nuorodas (pointers)
}
//------------------------------------------------------------
void GroupList::printSarasa() {
   cout << "====================================================" << endl;
   groupList.sort(Palyginti());
   list<Shop*>::iterator vi = groupList.begin();

   for (;  vi != groupList.end();  vi++)
      (*vi)->printGroup();
   cout << "====================================================" << endl;
}
//------------------------------------------------------------
void GroupList::iSarasa(std::string grupe, std::string name, std::string date)
{
  list<Shop*>::iterator i=groupList.begin();
  while((i!=groupList.end())&&((*i)->getGrupe()!=grupe))
    i++;
  if(i==groupList.end())
  {
    Shop* g=new Shop(grupe);
    g->iSarasa(name, date);
    groupList.push_back(g);
  }
  else
    (*i)->iSarasa(name, date);
}
//------------------------------------------------------------
void GroupList::addToSarasas() {
   string grupe;
   string name;
   string data;
   cout << "Kuriai GRUPEI priskirti nauja irasa: ";
   cin >> grupe;
   cout << "Atlikto darbo pavadinimas: ";
   cin >> name;
   cout << "Data (MMMM-mm-dd): ";
   cin >> data;
   list<Shop*>::iterator iter = groupList.begin();
      for (;  iter != groupList.end();  iter++) {
      string grupeX = (*iter)->getGrupe();
         if (grupeX == grupe) {
            (*iter)->iSarasa(name,data);
            break;
         }
      }
}
//------------------------------------------------------------
void GroupList::createNewGroup() {
   string grupe;
   cout << "Kaip vadinsis nauja GRUPE : ";
   cin >> grupe;
   groupList.push_back(new Shop(grupe));
}
//------------------------------------------------------------
void GroupList::printLaikotarpi() {
   string dataNuo;
   string dataIki;
   cout << "Nuo kada (MMMM-mm-dd): ";
   cin >> dataNuo;
   cout << "Iki kada (MMMM-mm-dd): ";
   cin >> dataIki;
   list<Shop*>::iterator iter = groupList.begin();
   for (;  iter != groupList.end();  iter++)
      (*iter)->printGroupPagalLaika(dataNuo, dataIki);
}
//------------------------------------------------------------
void GroupList::printVienaSarasa(){
   string grupe;
   cout << "Kurios GRUPES spausdinti darbu sarasa: ";
   cin >> grupe;
   list<Shop*>::iterator iter = groupList.begin();
   for (;  iter != groupList.end();  iter++) {
      string grupeX = (*iter)->getGrupe();
      if (grupeX == grupe)
         (*iter)->printGroup();
   }
}
//------------------------------------------------------------
int main () {
   GroupList groupList;
   groupList.iSarasa("EGZAMINAS","nupirkta_nauja_knyga","2005-12-13");
   groupList.iSarasa("EGZAMINAS","perskaityta_knyga"   ,"2006-01-02");
   groupList.iSarasa("EGZAMINAS","parasytas_konspektas","2006-01-07");
   groupList.iSarasa("EGZAMINAS","islaikytas_egzaminas","2006-01-23");
   groupList.iSarasa("ATOSTOGOS","suplanuota_isvyka"   ,"2005-12-26");
   groupList.iSarasa("ATOSTOGOS","nupirkti_du_biletai" ,"2005-12-28");
   groupList.iSarasa("ATOSTOGOS","isvykimas_i_Graikija","2005-12-30");
   for (;;) {
      cout << endl
           << "Meniu:"                                                              << endl
           << "  1 - Parodyti visa grupiu ir darbu sarasa."                         << endl
           << "  2 - Papildyti egzistuojancias grupes naujais irasais."             << endl
           << "  3 - Kurti naujas darbo grupes."                                    << endl
           << "  4 - Pasirinkto laikotarpio visu darbu is visu grupiu sarasas."     << endl
           << "  5 - Spausdinti pasirinktos grupes darbu sarasa."                   << endl
           <<  endl
           << "  0 - Baigti darba."                                                 << endl;
      string key;
      cin >> key;
           if (key == "0") return 0;
      else if (key == "1") groupList.printSarasa();
      else if (key == "2") groupList.addToSarasas();
      else if (key == "3") groupList.createNewGroup();
      else if (key == "4") groupList.printLaikotarpi();
      else if (key == "5") groupList.printVienaSarasa();
      else cout << endl << "Neteisingas veiksmas..." << endl;
   }
}
